SystemOrganization addCategory: #'Felipe-Easel'!

GLMMorphicWidgetRenderer subclass: #GLMMorphicRoassalRenderer
	instanceVariableNames: 'canvasScrollPane roassalCanvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Felipe-Easel'!

!GLMMorphicRoassalRenderer methodsFor: 'as yet unclassified' stamp: 'FelipeGonzlezMartnez 12/16/2011 11:07'!
actOnContextChanged: ann
	ann property = #selection ifTrue: [ 
		roassalCanvas selected: (roassalCanvas root deepFindNodeWithEntity: ann value) ]! !

!GLMMorphicRoassalRenderer methodsFor: 'as yet unclassified' stamp: 'FelipeGonzlezMartnez 12/20/2011 16:36'!
actOnPresentationUpdate: ann
	ann presentation view: ROView new.
	canvasScrollPane scroller removeMorph: canvasScrollPane scroller submorphs first.
	self roassalCanvasFor: ann presentation! !

!GLMMorphicRoassalRenderer methodsFor: 'as yet unclassified' stamp: 'FelipeGonzlezMartnez 12/21/2011 23:51'!
render: aPresentation
	canvasScrollPane := ScrollPane new.
	self roassalCanvasFor: aPresentation.
	canvasScrollPane
		color: Color white;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	aPresentation on: GLMPresentationUpdated send: #actOnPresentationUpdate: to: self.
	aPresentation on: GLMContextChanged send: #actOnContextChanged: to: self.
	^ canvasScrollPane! !

!GLMMorphicRoassalRenderer methodsFor: 'as yet unclassified' stamp: 'FelipeGonzlezMartnez 12/21/2011 23:50'!
roassalCanvasFor: aPresentation
	| view |
	view := aPresentation view.
	view inspect.
	"view root interaction menu: [ :x | self menuIn: MenuMorph new for: aPresentation ]."
	aPresentation renderOn: view.
	"
	roassalRenderer interaction 
			when: ROElement
			do: [ :ann | aPresentation selection: ann element model ].
	roassalRenderer interaction
			when: ROMouseEnter
			do: [ :ann | aPresentation status: ann element model ].
	roassalRenderer interaction
			when: ROMouseLeave
			do: [ :ann | aPresentation status: nil ].
	"
	roassalCanvas := aPresentation canvas.
	canvasScrollPane scroller addMorph: roassalCanvas
! !

GLMScriptingEditorTemplate subclass: #FelipeEasel
	instanceVariableNames: 'canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Felipe-Easel'!

!FelipeEasel commentStamp: 'FelipeGonzlezMartnez 12/21/2011 23:56' prior: 0!
To open, in a workspace:
	FelipeEasel open.

2011_12_15:
	First implementation of Roassal Easel.
	I haven't finished yet, there's some problems with the methods 'roassalCanvasFor:' 
	
2011_12_21:
	Second one.
	Some improvements. With a couple of hours and some guidance could help.!

!FelipeEasel class methodsFor: 'as yet unclassified' stamp: 'FelipeGonzlezMartnez 12/15/2011 14:55'!
open
	^ self new open! !

!FelipeEasel methodsFor: 'as yet unclassified' stamp: 'FelipeGonzlezMartnez 12/21/2011 23:37'!
buildBrowser
	browser := GLMTabulator new.
	browser
		row: #result span: 2;
		row: [ :r | r
			column: #script span: 3;
			column: #variables span: 2].

	browser transmit 
		to: #script; 
		andShow: [ :a | self scriptIn: a ].
	browser transmit
		to: #variables;
		andShow: [ :a | self variablesIn: a ].
	browser transmit
		to: #result; 
		fromOutsidePort: #entity;
		from: #script;
		andShow: [ :a | self resultIn: a ].
	^ browser! !

!FelipeEasel methodsFor: 'as yet unclassified' stamp: 'FelipeGonzlezMartnez 12/21/2011 23:42'!
decreaseZoom

	self canvas root decreaseZoom.
	self canvas root updateWindow.! !

!FelipeEasel methodsFor: 'as yet unclassified' stamp: 'FelipeGonzlezMartnez 12/21/2011 23:45'!
defaultScriptBindings
	^ {#view -> ROView new}! !

!FelipeEasel methodsFor: 'as yet unclassified' stamp: 'FelipeGonzlezMartnez 12/21/2011 22:56'!
defaultScriptDisplayIn: aPresentation
	^ aPresentation display: 'view'! !

!FelipeEasel methodsFor: 'as yet unclassified' stamp: 'FelipeGonzlezMartnez 12/15/2011 15:42'!
defaultTitle
	^ 'Roassal Easel'! !

!FelipeEasel methodsFor: 'as yet unclassified' stamp: 'FelipeGonzlezMartnez 12/21/2011 23:43'!
increaseZoom

	self canvas root increaseZoom.
	self canvas root updateWindow.! !

!FelipeEasel methodsFor: 'as yet unclassified' stamp: 'FelipeGonzlezMartnez 12/21/2011 15:01'!
open
	self buildBrowser.
	self setTitleOf: browser.	
	browser openOn: ''.! !

!FelipeEasel methodsFor: 'as yet unclassified' stamp: 'FelipeGonzlezMartnez 12/21/2011 23:52'!
resultIn: a
	^ a roassal
	title: 'Result';
	painting: [ :view :bindings :script | 
			| context |
			context := GLMContext with: #view -> view withAll: bindings.
			Compiler new evaluate: script in: context to: context ];
		"act: [ :m | m canvas exportAsPNG ] entitled: 'Export as PNG';
		act: [ :m | m canvas exportAsJPEG ] entitled: 'Export as JPEG';
		act: [ :m | m canvas exportAsSVG ] entitled: 'Export as SVG';
		act: [ :m | m canvas exportAsTikz ] entitled: 'Export as Tikz';
		act: [ :m | m canvas exportAsXML ] entitled: 'Export as XML';"
		act: [ :m | 
					m canvas root decreaseZoom.
					m canvas changed ]
			icon: MondrianIcons mondrianZoomOut
			entitled: 'Zoom out';
		act: [ :m | 
					m canvas root increaseZoom.
					m canvas changed ]
			icon: MondrianIcons mondrianZoomIn
			entitled: 'Zoom in'! !

!FelipeEasel methodsFor: 'as yet unclassified' stamp: 'FelipeGonzlezMartnez 12/21/2011 23:07'!
scriptIn: a
	^ a smalltalkCode
		title: 'Roassal Code';
		variableBindings: [ :bindings |
			| col |
			col := OrderedCollection withAll: bindings.
			col addAll: self defaultScriptBindings.
			col ];
		with: [ :p | self defaultScriptDisplayIn: p ] ;
		populate: #selection
			icon: GLMUIThemeExtraIcons glamorousAccept 
			on: $d
			entitled: 'Accept' 
			with: [:text | text text ].! !

!FelipeEasel methodsFor: 'as yet unclassified' stamp: 'FelipeGonzlezMartnez 12/15/2011 16:20'!
setTitleOf: title
	title title: self defaultTitle! !

!FelipeEasel methodsFor: 'as yet unclassified' stamp: 'FelipeGonzlezMartnez 12/21/2011 23:37'!
variablesIn: a
	^ a table
		selectionAct: [:t | t selection value inspect ] on: $i entitled: 'Inspect';
		selectionAct: [:t | t selection value explore ] on: $I entitled: 'Explore';		
		column: 'Variable' evaluated: [ :each | each key asString ];
		column: 'Value' evaluated: [ :each | each value asString contractTo: 20 ]! !

!GLMCompositePresentation methodsFor: '*felipe-easel' stamp: 'FelipeGonzlezMartnez 12/15/2011 18:38'!
roassal
	^ self custom: GLMRoassalPresentation new! !

!GLMMorphicRenderer methodsFor: '*felipe-easel' stamp: 'FelipeGonzlezMartnez 12/15/2011 19:09'!
renderRoassalPresentation: aPresentation
	^ GLMMorphicRoassalRenderer render: aPresentation from: self! !

GLMPresentation subclass: #GLMRoassalPresentation
	instanceVariableNames: 'painting view canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Felipe-Easel'!

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'FelipeGonzlezMartnez 12/15/2011 18:02'!
canvas
	 ^ canvas! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'FelipeGonzlezMartnez 12/15/2011 18:02'!
canvas: anObject
	canvas := anObject! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'FelipeGonzlezMartnez 12/15/2011 18:03'!
painting	 
	^painting! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'FelipeGonzlezMartnez 12/15/2011 18:02'!
painting: anObject 	 
	painting := anObject! !

!GLMRoassalPresentation methodsFor: 'rendering' stamp: 'FelipeGonzlezMartnez 12/21/2011 21:36'!
renderOn: aView
	self flag: 'find a smarter solution that does not depend on isKindOf:'. 
	self painting glamourValue: (
		(self entity isKindOf: GLMMultiValue) 
				ifTrue: [(GLMMultiValue with: aView) , self entity , (GLMMultiValue with: self)] 
				ifFalse: [GLMMultiValue with: aView with: self entity with: self]).
	self canvas: aView view! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'FelipeGonzlezMartnez 12/21/2011 23:26'!
view
	^ view ifNil: [view := ROView new]! !

!GLMRoassalPresentation methodsFor: 'accessing' stamp: 'FelipeGonzlezMartnez 12/21/2011 23:26'!
view: anObject
	view := anObject! !
